Index: issm/trunk/src/m/miscellaneous/MatlabFuncs.py
===================================================================
--- issm/trunk/src/m/miscellaneous/MatlabFuncs.py	(revision 25994)
+++ issm/trunk/src/m/miscellaneous/MatlabFuncs.py	(revision 26744)
@@ -1,59 +1,206 @@
-def oshostname():
-    import socket
-
-    return socket.gethostname()
-
-
-def ispc():
+"""A collection of functions that replicate the behavior of MATLAB built-in
+functions of the same, respective name.
+
+Where possible, users are encouraged to use native and/or the most efficient 
+methods in Python, but we provide these functions as a way to make translations 
+from the MATLAB to the Python ISSM API more seamless.
+"""
+
+def acosd(X):  # {{{
+    """function acosd - Inverse cosine in degrees
+
+    Usage:
+        Y = acosd(X)
+    """
+    import numpy as np
+
+    return np.degrees(np.arccos(X))
+# }}}
+
+def asind(X):  # {{{
+    """function asind - Inverse sine in degrees
+
+    Usage:
+        Y = asind(X)
+    """
+    import numpy as np
+
+    return np.degrees(np.arcsin(X))
+# }}}
+
+def atand(X):  # {{{
+    """function atand - Inverse tangent in degrees
+
+    Usage:
+        Y = atand(X)
+    """
+    import numpy as np
+
+    return np.degrees(np.arctan(X))
+# }}}
+
+
+def atan2d(Y, X):  # {{{
+    """function atan2d - Four-quadrant inverse tangent in degrees
+
+    Usage:
+        D = atan2d(Y, X)
+    """
+    import numpy as np
+
+    return np.degrees(np.arctan2(Y, X))
+# }}}
+
+def contains(str, pat):  #{{{
+    """function contains - Determine if pattern is in strings
+
+    Usage:
+        TF = contains(str, pat)
+
+    TODO:
+    - Implement 'IgnoreCase' option
+    """
+
+# }}}
+
+def cosd(X):  # {{{
+    """function cosd - Cosine of argument in degrees
+
+    Usage:
+        Y = cosd(X)
+    """
+    import numpy as np
+
+    if type(X) == np.ndarray:
+        Y = np.array([])
+        for x in X:
+            Y = np.append(Y, cosdsingle(x))
+        return Y
+    else:
+        return cosdsingle(X)
+# }}}
+
+def cosdsingle(x):  # {{{
+    """function cosdsingle - Helper function for cosd to reduce repetition of 
+    logic
+
+    Usage:
+        y = cosdsingle(x)
+    """
+    import numpy as np
+
+    while x >= 360:
+        x = x - 360
+
+    if x == 0:
+        return 1
+    elif x == 90 or x == 270:
+        return 0
+    elif x == 180:
+        return -1
+    else:
+        return np.cos(np.radians(x))
+# }}}
+
+def det(a):  # {{{
+    if a.shape == (1, ):
+        return a[0]
+    elif a.shape == (1, 1):
+        return a[0, 0]
+    elif a.shape == (2, 2):
+        return a[0, 0] * a[1, 1] - a[0, 1] * a[1, 0]
+    else:
+        raise TypeError('MatlabFunc.det only implemented for shape (2, 2), not for shape {}.'.format(a.shape))
+# }}}
+
+def error(msg):  # {{{
+    raise Exception(msg)
+# }}}
+
+def etime(t2, t1):  # {{{
+    return t2 - t1
+# }}}
+
+def find(*args):  # {{{
+    nargs = len(args)
+    if nargs >= 1 or nargs <= 2:
+        X = args[0]
+        n = len(args[0])
+        if nargs == 2:
+            n = args[1]
+        indices=[]
+        for i in range(n):
+            if X[i] != 0:
+                indices.push(i)
+        return indices
+    else:
+        raise Exception('find: must have 1 or 2 arguments')
+# }}}
+
+def floor(X):  # {{{
+    import math
+
+    return int(math.floor(X))
+# }}}
+
+def heaviside(x):  # {{{
+    import numpy as np
+
+    y = np.zeros_like(x)
+    y[np.nonzero(x > 0.)] = 1.
+    y[np.nonzero(x == 0.)] = 0.5
+
+    return y
+# }}}
+
+def intersect(A, B):  # {{{
+    """function intersect - Set intersection of two arrays
+
+    Usage:
+        C = intersect(A, B)
+
+    NOTE:
+    - Only the following functionality is currently implemented:
+        - C = intersect(A,B) returns the data common to both A and B, with no 
+        repetitions. C is in sorted order.
+
+    """
+    import numpy as np
+
+    return np.intersect1d(A, B)
+#}}}
+
+def isa(A, dataType):  # {{{
+    """function isa
+
+    NOTE:
+    - Takes a type as its second argument (in contrast to the MATLAB function 
+    that it replicates, which takes a string representing the name of a type)
+    """
+    return type(A) == dataType
+# }}}
+
+# NOTE: Conflicts with definition of isempty in $ISSM_DIR/src/m/qmu/helpers.py
+#
+# def isempty(A):  # {{{
+#     return len(A) > 0
+# # }}}
+
+def isfile(fileName):  # {{{
+    import os
+
+    return os.path.exists(fileName)
+# }}}
+
+def ismac():  # {{{
     import platform
 
-    if 'Windows' in platform.system():
-        return True
-    else:
-        return False
-
-
-def ismac():
-    import platform
-
     if 'Darwin' in platform.system():
         return True
     else:
         return False
-
-
-def strcmp(s1, s2):
-
-    if s1 == s2:
-        return True
-    else:
-        return False
-
-
-def strncmp(s1, s2, n):
-
-    if s1[0:n] == s2[0:n]:
-        return True
-    else:
-        return False
-
-
-def strcmpi(s1, s2):
-
-    if s1.lower() == s2.lower():
-        return True
-    else:
-        return False
-
-
-def strncmpi(s1, s2, n):
-
-    if s1.lower()[0:n] == s2.lower()[0:n]:
-        return True
-    else:
-        return False
-
-
-def ismember(a, s):
+# }}}
+
+def ismember(a, s):  # {{{
     import numpy as np
 
@@ -66,5 +213,4 @@
     if not isinstance(a, np.ndarray):
         b = [item in s for item in a]
-
     else:
         if not isinstance(s, np.ndarray):
@@ -76,19 +222,102 @@
 
     return b
-
-
-def det(a):
-
-    if a.shape == (1, ):
-        return a[0]
-    elif a.shape == (1, 1):
-        return a[0, 0]
-    elif a.shape == (2, 2):
-        return a[0, 0] * a[1, 1] - a[0, 1] * a[1, 0]
-    else:
-        raise TypeError("MatlabFunc.det only implemented for shape (2, 2), not for shape %s." % str(a.shape))
-
-
-def sparse(ivec, jvec, svec, m=0, n=0, nzmax=0):
+# }}}
+
+def isnan(A):  # {{{
+    import numpy as np
+
+    return np.isnan(A)
+# }}}
+
+def ispc():  # {{{
+    import platform
+
+    if 'Windows' in platform.system():
+        return True
+    else:
+        return False
+# }}}
+
+def isprop(obj, PropertyName):  # {{{
+    return hasattr(obj, PropertyName)
+# }}}
+
+def mod(a, m):  # {{{
+    return a % m
+# }}}
+
+def numel(A):  # {{{
+    """function numel - Number of array elements
+
+    Usage:
+        n = numel(A))
+    """
+    import numpy as np
+
+    return np.size(A)
+# }}}
+
+def pause(n):  # {{{
+    import time
+
+    time.sleep(n)
+# }}}
+
+def pwd():  # {{{
+    import os
+
+    return os.getcwd()
+# }}}
+
+def oshostname():  # {{{
+    import socket
+
+    return socket.gethostname()
+# }}}
+
+def rem(a, b):  # {{{
+    return a % b
+# }}}
+
+def sind(X):  # {{{
+    """function sind - Sine of argument in degrees
+
+    Usage:
+        Y = sind(X)
+    """
+    import numpy as np
+
+    if type(X) == np.ndarray:
+        Y = np.array([])
+        for x in X:
+            Y = np.append(Y, sindsingle(x))
+        return Y
+    else:
+        return sindsingle(X)
+# }}}
+
+def sindsingle(x):  # {{{
+    """function sindsingle - Helper function for sind to reduce repetition of 
+    logic
+
+    Usage:
+        y = sindsingle(x)
+    """
+    import numpy as np
+
+    while x >= 360:
+        x = x - 360
+
+    if x == 0 or x == 180:
+        return 0
+    elif x == 90:
+        return 1
+    elif x == 270:
+        return -1
+    else:
+        return np.sin(np.radians(x))
+# }}}
+
+def sparse(ivec, jvec, svec, m=0, n=0, nzmax=0):  # {{{
     import numpy as np
 
@@ -104,12 +333,42 @@
 
     return a
-
-
-def heaviside(x):
-    import numpy as np
-
-    y = np.zeros_like(x)
-    y[np.nonzero(x > 0.)] = 1.
-    y[np.nonzero(x == 0.)] = 0.5
-
-    return y
+# }}}
+
+def strcmp(s1, s2):  # {{{
+    if s1 == s2:
+        return True
+    else:
+        return False
+# }}}
+
+def strcmpi(s1, s2):  # {{{
+    if s1.lower() == s2.lower():
+        return True
+    else:
+        return False
+# }}}
+
+def strjoin(*args):  # {{{
+    nargs = len(args)
+    if nargs >= 1 or nargs <= 2:
+        sep = ' '
+        if nargs == 2:
+            sep = args[1]
+        return sep.join(args[0])
+    else:
+        raise Exception('strjoin: must have 1 or 2 arguments')
+# }}}
+
+def strncmp(s1, s2, n):  # {{{
+    if s1[0:n] == s2[0:n]:
+        return True
+    else:
+        return False
+# }}}
+
+def strncmpi(s1, s2, n):  # {{{
+    if s1.lower()[0:n] == s2.lower()[0:n]:
+        return True
+    else:
+        return False
+# }}}
Index: issm/trunk/src/m/miscellaneous/PythonFuncs.py
===================================================================
--- issm/trunk/src/m/miscellaneous/PythonFuncs.py	(revision 25994)
+++ issm/trunk/src/m/miscellaneous/PythonFuncs.py	(revision 26744)
@@ -2,6 +2,5 @@
 
 
-def logical_and_n(*arg):
-
+def logical_and_n(*arg): #{{{
     if len(arg):
         result = arg[0]
@@ -9,11 +8,9 @@
             result = np.logical_and(result, item)
         return result
-
     else:
         return None
+#}}}
 
-
-def logical_or_n(*arg):
-
+def logical_or_n(*arg): #{{{
     if len(arg):
         result = arg[0]
@@ -21,5 +18,5 @@
             result = np.logical_or(result, item)
         return result
-
     else:
         return None
+#}}}
Index: issm/trunk/src/m/miscellaneous/prctile_issm.py
===================================================================
--- issm/trunk/src/m/miscellaneous/prctile_issm.py	(revision 25994)
+++ issm/trunk/src/m/miscellaneous/prctile_issm.py	(revision 26744)
@@ -41,5 +41,8 @@
         #  if one value, just copy it
         elif n == 1:
-            y = np.tile(x[0, :], (len(p), 1))
+            if isinstance(p, int):
+                y = x[0, :]
+            else:
+                y = np.tile(x[0, :], (len(p), 1))
 
         #  if no values, use NaN
Index: issm/trunk/src/m/miscellaneous/pretty_print.m
===================================================================
--- issm/trunk/src/m/miscellaneous/pretty_print.m	(revision 25994)
+++ issm/trunk/src/m/miscellaneous/pretty_print.m	(revision 26744)
@@ -30,10 +30,10 @@
 		if shape(2)>6
 			output=sprintf('[[%.8f %.8f %.8f ... %.8f %.8f %.8f]\n',data(1,1),data(1,2),data(1,3),data(1,end-2),data(1,end-1),data(1,end));
-			output=sprintf('%s [%.8f %.8f %.8f ... %.8f %.8f %.8f]\n',data(2,1),data(2,2),data(2,3),data(2,end-2),data(2,end-1),data(2,end));
-			output=sprintf('%s [%.8f %.8f %.8f ... %.8f %.8f %.8f]\n',data(3,1),data(3,2),data(3,3),data(3,end-2),data(3,end-1),data(3,end));
+			output=sprintf('%s [%.8f %.8f %.8f ... %.8f %.8f %.8f]\n',output,data(2,1),data(2,2),data(2,3),data(2,end-2),data(2,end-1),data(2,end));
+			output=sprintf('%s [%.8f %.8f %.8f ... %.8f %.8f %.8f]\n',output,data(3,1),data(3,2),data(3,3),data(3,end-2),data(3,end-1),data(3,end));
 			output=sprintf('%s ...\n',output);
-			output=sprintf('%s [%.8f %.8f %.8f ... %.8f %.8f %.8f]\n',data(end-2,1),data(end-2,2),data(end-2,3),data(end-2,end-2),data(end-2,end-1),data(end-2,end));
-			output=sprintf('%s [%.8f %.8f %.8f ... %.8f %.8f %.8f]\n',data(end-1,1),data(end-1,2),data(end-1,3),data(end-1,end-2),data(end-1,end-1),data(end-1,end));
-			output=sprintf('%s [%.8f %.8f %.8f ... %.8f %.8f %.8f]]',data(end,1),data(end,2),data(end,3),data(end,end-2),data(end,end-1),data(end,end));
+			output=sprintf('%s [%.8f %.8f %.8f ... %.8f %.8f %.8f]\n',output,data(end-2,1),data(end-2,2),data(end-2,3),data(end-2,end-2),data(end-2,end-1),data(end-2,end));
+			output=sprintf('%s [%.8f %.8f %.8f ... %.8f %.8f %.8f]\n',output,data(end-1,1),data(end-1,2),data(end-1,3),data(end-1,end-2),data(end-1,end-1),data(end-1,end));
+			output=sprintf('%s [%.8f %.8f %.8f ... %.8f %.8f %.8f]]',output,data(end,1),data(end,2),data(end,3),data(end,end-2),data(end,end-1),data(end,end));
 		else
 			output=sprintf('[[%.8f]\n',data(1,:));
Index: issm/trunk/src/m/modules/CoordTransform.m
===================================================================
--- issm/trunk/src/m/modules/CoordTransform.m	(revision 25994)
+++ issm/trunk/src/m/modules/CoordTransform.m	(revision 26744)
@@ -10,8 +10,8 @@
 %
 %   Example of Projections:
-%      
+%
 %   lat/lon = '+init=epsg:4326'
 %   lat/lon = '+proj=longlat +datum=WGS84'
-%   
+%
 %   ll2xy default equivalent (uses with Hugues Ellispoid S)
 %   Greenland = '+proj=stere +lat_0=90 +lat_ts=70 +lon_0=-45 +k=1 +x_0=0 +y_0=0 +a=6378273 +b=6356889.448564109 +units=m +no_defs'
@@ -19,7 +19,9 @@
 %   Bamber Greenland = '+proj=stere +lat_0=90 +lat_ts=71 +lon_0=-39 +k=1 +x_0=0 +y_0=0 +ellps=WGS84 +datum=WGS84 +units=m +no_defs'
 %
-%   for latitude/longitude, x is longitude and y latitude and the angles are in rad
+%   For latitude/longitude, x is longitude and y latitude and the angles are in 
+%   rad
 %
-%   This function will only work of PROJ has been installed in externalpackages
+%   This function will only work if PROJ has been installed and --with-proj-dir 
+%   option has been set to its location in ISSM configuration
 
 % Check usage
Index: issm/trunk/src/m/modules/ExpToLevelSet.m
===================================================================
--- issm/trunk/src/m/modules/ExpToLevelSet.m	(revision 25994)
+++ issm/trunk/src/m/modules/ExpToLevelSet.m	(revision 26744)
@@ -18,12 +18,35 @@
 end
 
+multipleShp = 0;
+
 if ischar(contourname),
-	[path,name,ext]=fileparts(contourname); 
+	[path,name,ext]=fileparts(contourname);
 	if strcmpi(ext,'.shp'),
 		%read contour from shapefile
-		contourname=shpread(contourname); 
+		contourname=shpread(contourname);
+		if isstruct(contourname)
+			multipleShp = size(contourname, 2);
+		end
 	end
 end
 
 % Call mex module
-distance = ExpToLevelSet_matlab(x,y,contourname);
+if multipleShp>0 
+	% shp file contains multiple contours
+	distance = zeros(length(x)+1, multipleShp);
+	for i = 1:multipleShp
+		distance(1:end-1, i) = ExpToLevelSet_matlab(x,y,contourname(i));
+		% append the NAME information at the end of the distance
+		if isfield(contourname(i),'NAME')
+			distance(end, i) = contourname(i).NAME;
+		elseif isfield(contourname(i),'Date')
+			distance(end, i) = date2decyear(datenum(contourname(i).Date));
+			% to deal with 
+		else
+			distance(end, i) = i;
+		end        
+	end
+else
+	% single shape or exp file
+	distance = ExpToLevelSet_matlab(x,y,contourname);
+end
Index: issm/trunk/src/m/modules/ExpToLevelSet.py
===================================================================
--- issm/trunk/src/m/modules/ExpToLevelSet.py	(revision 25994)
+++ issm/trunk/src/m/modules/ExpToLevelSet.py	(revision 26744)
@@ -1,2 +1,3 @@
+from ExpToLevelSet_python import ExpToLevelSet_python
 from helpers import fileparts
 from shpread import shpread
@@ -23,5 +24,5 @@
     """
 
-    if isinstance(contourname, basestring):
+    if isinstance(contourname, str):
         path, name, ext = fileparts(contourname)
         if ext == '.shp':
@@ -29,5 +30,5 @@
             contourname = shpread(contourname)
 
-    # NOTE: This library does not currently exist! See TODO list in function 
+    # NOTE: This module does not currently exist! See TODO list in function 
     #       header.
     distance = ExpToLevelSet_python(x, y, contourname)
Index: issm/trunk/src/m/modules/InterpFromGridToMesh.py
===================================================================
--- issm/trunk/src/m/modules/InterpFromGridToMesh.py	(revision 25994)
+++ issm/trunk/src/m/modules/InterpFromGridToMesh.py	(revision 26744)
@@ -1,2 +1,3 @@
+import numpy as np
 from InterpFromGridToMesh_python import InterpFromGridToMesh_python
 
@@ -21,3 +22,3 @@
     data_mesh = InterpFromGridToMesh_python(x, y, data, x_mesh, y_mesh, default_value)
     # Return
-    return data_mesh
+    return np.squeeze(data_mesh)
Index: issm/trunk/src/m/modules/ShpRead.m
===================================================================
--- issm/trunk/src/m/modules/ShpRead.m	(revision 25994)
+++ issm/trunk/src/m/modules/ShpRead.m	(revision 26744)
@@ -1,3 +1,3 @@
-function ShpRead(filename);
+function structout = ShpRead(filename);
 %	SHPREAD - Read shapefile
 %	
@@ -5,9 +5,8 @@
 %	
 %	   Usage:
-%	      ShpRead(filename);
-%	      filexp:      file name of exp file to be written
+%	      structout = ShpRead(filename);
 %	
 %	   Examples:
-%	      ShpRead('file.shp');
+%	      structout = ShpRead('file.shp');
 
 % Check usage
@@ -18,3 +17,3 @@
 
 % Call mex module
-ShpRead_matlab(filename);
+structout = ShpRead_matlab(filename);
Index: issm/trunk/src/m/os/ismingw.m
===================================================================
--- issm/trunk/src/m/os/ismingw.m	(revision 26744)
+++ issm/trunk/src/m/os/ismingw.m	(revision 26744)
@@ -0,0 +1,11 @@
+function result=ismingw()
+%ISMINGW - Returns 1 if machine is running MinGW.
+%
+%   Usage:
+%      if ismingw,
+%         [...]
+%      end
+%
+
+[status,result]=system('uname -rs | grep "MINGW" | wc -l');
+result=str2num(result);
Index: issm/trunk/src/m/os/issmscpin.m
===================================================================
--- issm/trunk/src/m/os/issmscpin.m	(revision 25994)
+++ issm/trunk/src/m/os/issmscpin.m	(revision 26744)
@@ -18,12 +18,9 @@
 %if hostname and host are the same, do a simple copy
 if strcmpi(hostname,host),
-
-    for i=1:numel(packages),
+	for i=1:numel(packages),
 		success=copyfile([path '/' packages{i}]); %keep going, even if success=0
 	end
-
 else
-
-	if ispc(),
+	if ispc & ~ismingw,
 		%use the putty project pscp.exe: it should be in the path.
 
Index: issm/trunk/src/m/os/issmscpin.py
===================================================================
--- issm/trunk/src/m/os/issmscpin.py	(revision 25994)
+++ issm/trunk/src/m/os/issmscpin.py	(revision 26744)
@@ -1,17 +1,17 @@
-from socket import gethostname
-import subprocess
 import os
 import shutil
-import MatlabFuncs as m
+import subprocess
+from MatlabFuncs import *
 
 
 def issmscpin(host, login, port, path, packages):
-    """
-    ISSMSCPIN get packages from host, using scp on unix, and pscp on windows
-       usage: issmscpin(host, packages, path)
+    """ISSMSCPIN get packages from host, using scp on unix, and pscp on windows
+
+    Usage:
+        issmscpin(host, packages, path)
     """
 
     #first get hostname
-    hostname = gethostname()
+    hostname = oshostname()
     #first be sure packages are not in the current directory, this could conflict with pscp on windows.
     #remove warnings in case the files do not exist
@@ -29,5 +29,5 @@
                 pass
     else:
-        if m.ispc():
+        if ispc():
             #use the putty project pscp.exe: it should be in the path.
             #get ISSM_DIR variable
Index: issm/trunk/src/m/os/issmscpout.m
===================================================================
--- issm/trunk/src/m/os/issmscpout.m	(revision 25994)
+++ issm/trunk/src/m/os/issmscpout.m	(revision 26744)
@@ -9,5 +9,5 @@
 hostname=oshostname();
 
-%are we dis-allowing symbolic links? 
+%are we disallowing symbolic links? 
 if nargin==6,
 	no_symlinks=1;
@@ -24,5 +24,5 @@
 		system(['rm -rf ' packages{i} ]);
 		if no_symlinks,
-			system(['cp  ' here '/' packages{i} ' .']);
+			system(['cp ' here '/' packages{i} ' .']);
 		else
 			system(['ln -s ' here '/' packages{i} ' .']);
@@ -31,5 +31,5 @@
 	end
 else 
-	if ispc(),
+	if ispc & ~ismingw,
 		%use the putty project pscp.exe: it should be in the path.
 
Index: issm/trunk/src/m/os/issmscpout.py
===================================================================
--- issm/trunk/src/m/os/issmscpout.py	(revision 25994)
+++ issm/trunk/src/m/os/issmscpout.py	(revision 26744)
@@ -1,17 +1,17 @@
+import os
 from socket import gethostname
 import subprocess
-import os
-import MatlabFuncs as m
+from MatlabFuncs import *
 
 
 def issmscpout(host, path, login, port, packages):
-    """
-    ISSMSCPOUT send packages to a host, using scp on unix, and pscp on windows
+    """ISSMSCPOUT send packages to a host, using scp on unix, and pscp on windows
 
-       usage: issmscpout(host, path, packages)
+    Usage:
+        issmscpout(host, path, packages)
     """
 
     #get hostname
-    hostname = gethostname()
+    hostname = oshostname()
 
     #if hostname and host are the same, do a simple copy
@@ -28,5 +28,5 @@
             os.chdir(here)
     else:
-        if m.ispc():
+        if ispc():
             #use the putty project pscp.exe: it should be in the path.
             #get ISSM_DIR variable
Index: issm/trunk/src/m/os/issmssh.m
===================================================================
--- issm/trunk/src/m/os/issmssh.m	(revision 25994)
+++ issm/trunk/src/m/os/issmssh.m	(revision 26744)
@@ -12,5 +12,5 @@
 	system(command);
 else
-	if ispc(),
+	if ispc & ~ismingw,
 		%use the putty project plink.exe: it should be in the path.
 
Index: issm/trunk/src/m/os/issmssh.py
===================================================================
--- issm/trunk/src/m/os/issmssh.py	(revision 25994)
+++ issm/trunk/src/m/os/issmssh.py	(revision 26744)
@@ -1,25 +1,23 @@
-from socket import gethostname
+import os
+import subprocess
 from sys import platform as _platform
-import subprocess
-import os
-import MatlabFuncs as m
+from MatlabFuncs import *
 
 
 def issmssh(host, login, port, command):
-    """
-    ISSMSSH - wrapper for OS independent ssh command.
+    """ISSMSSH - wrapper for OS independent ssh command.
 
-       usage:
-          issmssh(host, command)
+    Usage:
+        issmssh(host, command)
     """
 
     #first get hostname
-    hostname = gethostname()
+    hostname = oshostname()
 
     #if same as host, just run the command.
-    if m.strcmpi(host, hostname):
+    if strcmpi(host, hostname):
         subprocess.call(command, shell=True)
     else:
-        if m.ispc():
+        if ispc():
             #use the putty project plink.exe: it should be in the path.
             #get ISSM_DIR variable
Index: issm/trunk/src/m/os/oshostname.m
===================================================================
--- issm/trunk/src/m/os/oshostname.m	(revision 25994)
+++ issm/trunk/src/m/os/oshostname.m	(revision 26744)
@@ -22,5 +22,5 @@
 %Method 3, last chance
 if isempty(hostname),
-	if ispc
+	if ispc % If OS is MinGW, $COMPUTERNAME and $HOSTNAME are identical
 		hostname = getenv('COMPUTERNAME');
 	else
Index: issm/trunk/src/m/parameterization/parameterize.py
===================================================================
--- issm/trunk/src/m/parameterization/parameterize.py	(revision 25994)
+++ issm/trunk/src/m/parameterization/parameterize.py	(revision 26744)
@@ -4,17 +4,16 @@
 
 def parameterize(md, parametername):
-    '''
-    PARAMETERIZE - parameterize a model
+    """PARAMETERIZE - parameterize a model
 
-        From a parameter Python file, start filling in all the model fields 
-        that were not filled in by the mesh.py and mask.py model methods.
-        Warning: the parameter file must be able to be run in Python
+    From a parameter Python file, start filling in all the model fields that 
+    were not filled in by the mesh.py and mask.py model methods. Warning: the 
+    parameter file must be able to be run in Python
 
-        Usage:
-            md = parameterize(md, parametername)
+    Usage:
+        md = parameterize(md, parametername)
 
-        Example:
-            md = parameterize(md, 'Square.par')
-    '''
+    Example:
+        md = parameterize(md, 'Square.py')
+    """
 
     #some checks
Index: issm/trunk/src/m/parameterization/reinitializelevelset.py
===================================================================
--- issm/trunk/src/m/parameterization/reinitializelevelset.py	(revision 26744)
+++ issm/trunk/src/m/parameterization/reinitializelevelset.py	(revision 26744)
@@ -0,0 +1,39 @@
+import numpy as np
+from model import model
+from contourlevelzero import *
+from ExpToLevelSet import *
+
+def reinitializelevelset(md,levelset):
+    """REINITIALIZELEVELSET - reinitialize levelset as a signed distance function
+
+    Usage:
+       levelsetnew = reinitializelevelset(md,levelset)
+    """
+    
+    # if md is 3d, levelset should be projected on a 2d mesh 
+    if len(levelset) == 0:
+        raise IOError("levelset provided is empty")
+    
+    if md.mesh.dimension() == 3:
+        if len(levelset)!=md.mesh.numberofvertices2d:
+            raise IOError("levelset provided should be specified at the 2d vertices of the mesh")
+        else:
+            if len(levelset)!=md.mesh.numberofvertices:
+                raise IOError("levelset provided should be specified at the vertices of the mesh")
+            
+    #First: extract segments
+    contours=contourlevelzero(md,levelset,0)
+    
+    #Now, make this a distance field (might not be closed)
+    levelsetnew=np.abs(ExpToLevelSet(md.mesh.x,md.mesh.y,contours)).T # levelsetnew comes on the 3d vertices, if mesh is 3d
+    
+    #Finally, change sign
+    pos=np.where(levelset<0) # if mesh is 3d, it refers to the vertices on the base
+    if md.mesh.dimension()==3:
+        for i in range(md.mesh.numberoflayers):
+            pos3d=pos[0]+i*md.mesh.numberofvertices2d
+            levelsetnew[pos3d]=-levelsetnew[pos3d]
+    else:
+        levelsetnew[pos[0]]=-1*levelsetnew[pos[0]]
+        
+    return levelsetnew
Index: issm/trunk/src/m/parameterization/setflowequation.m
===================================================================
--- issm/trunk/src/m/parameterization/setflowequation.m	(revision 25994)
+++ issm/trunk/src/m/parameterization/setflowequation.m	(revision 26744)
@@ -60,5 +60,5 @@
 %check that each element has only one flag
 if any(SIAflag+SSAflag+HOflag+L1L2flag+MLHOflag+FSflag>1),
-	disp('setflowequation warning message: some elements have several types, higher order type is used for them')
+	disp('setflowequation.m: Warning: some elements have several types, higher order type is used for them')
 	SIAflag(find(SIAflag & SSAflag))=0;
 	SIAflag(find(SIAflag & HOflag))=0;
Index: issm/trunk/src/m/parameterization/setflowequation.py
===================================================================
--- issm/trunk/src/m/parameterization/setflowequation.py	(revision 25994)
+++ issm/trunk/src/m/parameterization/setflowequation.py	(revision 26744)
@@ -6,22 +6,23 @@
 
 def setflowequation(md, *args):
-    """
-    SETFLOWEQUATION - associate a solution type to each element
-
-       This routine works like plotmodel: it works with an even number of inputs
-       'SIA', 'SSA', 'HO', 'L1L2', 'MLHO', 'FS' and 'fill' are the possible options
-       that must be followed by the corresponding exp file or flags list
-       It can either be a domain file (argus type, .exp extension), or an array of element flags.
-       If user wants every element outside the domain to be
-       setflowequationd, add '~' to the name of the domain file (ex: '~HO.exp')
-       an empty string '' will be considered as an empty domain
-       a string 'all' will be considered as the entire domain
-       You can specify the type of coupling, 'penalties' or 'tiling', to use with the input 'coupling'
-
-       Usage:
-          md = setflowequation(md, varargin)
-
-       Example:
-          md = setflowequation(md, 'HO', 'HO.exp', fill', 'SIA', 'coupling', 'tiling')
+    """SETFLOWEQUATION - associate a solution type to each element
+
+    This routine works like plotmodel: it works with an even number of inputs
+    'SIA', 'SSA', 'HO', 'L1L2', 'MLHO', 'FS' and 'fill' are the possible 
+    options that must be followed by the corresponding exp file or flags list. 
+    It can either be a domain file (argus type, .exp extension), or an array of 
+    element flags.
+    If user wants every element outside the domain to be setflowequationd, add 
+    '~' to the name of the domain file (ex: '~HO.exp') an empty string '' will 
+    be considered as an empty domain a string 'all' will be considered as the 
+    entire domain.
+    You can specify the type of coupling, 'penalties' or 'tiling', to use with 
+    the input 'coupling'.
+
+    Usage:
+        md = setflowequation(md, varargin)
+
+    Example:
+        md = setflowequation(md, 'HO', 'HO.exp', fill', 'SIA', 'coupling', 'tiling')
     """
 
@@ -61,5 +62,5 @@
     #check that each element has only one flag
     if any(SIAflag + SSAflag + L1L2flag + MLHOflag + HOflag + FSflag > 1):
-        print("setflowequation warning message: some elements have several types, higher order type is used for them")
+        print('Warning: setflowequation.py: some elements have several types, higher order type is used for them')
         SIAflag[np.where(np.logical_and(SIAflag, SSAflag))] = False
         SIAflag[np.where(np.logical_and(SIAflag, HOflag))] = False
Index: issm/trunk/src/m/plot/applyoptions.js
===================================================================
--- issm/trunk/src/m/plot/applyoptions.js	(revision 25994)
+++ issm/trunk/src/m/plot/applyoptions.js	(revision 26744)
@@ -1,3 +1,5 @@
-function applyoptions(md, data, options, canvas){ //{{{
+'use strict';
+
+function applyoptions(md, data, options, canvas) {
 	//APPLYOPTIONS - apply colobar, text, cloud, and expdisp options to current plot
 	//
